﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;

namespace ManualSortingGroupBy
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private ItemCollection _items = new ItemCollection();

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {
            _items.Add(new Item { Manufacture = "Samsung", Name = "Galaxy S III 16GB Black", Price = new decimal(599.00) });
            _items.Add(new Item { Manufacture = "Samsung", Name = "Galaxy S III 16GB White", Price = new decimal(595.00) });
            _items.Add(new Item { Manufacture = "Samsung", Name = "Galaxy Beam", Price = new decimal(475.00) });
            _items.Add(new Item { Manufacture = "HTC", Name = "HTC Sensation XL LE White", Price = new decimal(541.00) });
            _items.Add(new Item { Manufacture = "HTC", Name = "HTC One X White", Price = new decimal(494.95) });
            _items.Add(new Item { Manufacture = "HTC", Name = "HTC One X Grey", Price = new decimal(494.95) });

            this.DataContext = CollectionViewSource.GetDefaultView(_items);
        }

        private DataRecord FindDataRecord(GroupByRecord gbr)
        {
            {
                DataRecord rec = null;
                if (gbr.HasChildren)
                {
                    rec = gbr.ChildRecords[0] as DataRecord;
                    if (rec == null)
                        return FindDataRecord(gbr.ChildRecords[0] as GroupByRecord);
                }
                return rec;
            }
        }

        private void XamDataGrid1_Sorting(object sender, Infragistics.Windows.DataPresenter.Events.SortingEventArgs e)
        {
            // TODO : Manual sorting..
        }

        private void XamDataGrid1_Sorted(object sender, Infragistics.Windows.DataPresenter.Events.SortedEventArgs e)
        {
            // TODO : Manual sorting..
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            _items.Add(new Item { Manufacture = "Samsung", Name = "Galaxy Note (i9220 - n7000) Black", Price = new decimal(430.00) });
            _items.Add(new Item { Manufacture = "Samsung", Name = "Galaxy Note (i9220 - n7000) White", Price = new decimal(429.00) });
            _items.Add(new Item { Manufacture = "Apple", Name = "iPhone 4S 64GB Black", Price = new decimal(740.00) });
            _items.Add(new Item { Manufacture = "Apple", Name = "iPhone 4S 64GB White", Price = new decimal(740.00) });
            _items.Add(new Item { Manufacture = "Apple", Name = "iPhone 4 32GB Black", Price = new decimal(593.42) });
        }

        private FieldSortDescription sort = null;
        /// <summary>
        /// Remember the sortdescription after un-group.
        /// See: http://community.infragistics.com/forums/p/55779/286857.aspx#286857
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void XamDataGrid1_Grouped(object sender, Infragistics.Windows.DataPresenter.Events.GroupedEventArgs e)
        {
            if (sort != null && !e.FieldLayout.SortedFields.Contains(sort.Field))
            {
                int index = 0;
                foreach (var sortedField in e.FieldLayout.SortedFields)
                {
                    if (sortedField.Field.Index >= sort.Field.Index)
                    {
                        e.FieldLayout.SortedFields.Insert(index, sort);
                        break;
                    }
                    index++;
                }
            }
        }

        /// <summary>
        /// Remember the sortdescription after un-group.
        /// See: http://community.infragistics.com/forums/p/55779/286857.aspx#286857
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void XamDataGrid1_Grouping(object sender, Infragistics.Windows.DataPresenter.Events.GroupingEventArgs e)
        {
            FieldSortDescription sortDesc = null;
            if (e.FieldLayout.SortedFields.Count > e.Groups.Count())
            {
                foreach (var item in e.FieldLayout.SortedFields)
                {
                    bool temp = false;
                    foreach (var gr in e.Groups)
                    {
                        if (item.Equals(gr))
                        {
                            temp = temp || true;
                        }
                        else
                        {
                            temp = temp || false;
                        }
                    }
                    if (!temp)
                    {
                        sortDesc = item;
                        break;
                    }
                }

                if (sortDesc.IsGroupBy)
                {
                    sort = new FieldSortDescription();
                    sort.Field = sortDesc.Field;
                    sort.Direction = sortDesc.Direction;
                    sort.FieldName = sortDesc.FieldName;
                    sort.IsGroupBy = false;
                }
            }
        }
    }

    public class Item {
        public string Manufacture { get; set; }
        public string Name { get; set; }
        public Decimal Price { get; set; }
    }

    public class ItemCollection : ObservableCollection<Item> {
    }
}
